/*
 * Copyright (C) 2004, 2005 Nokia
 * Author: lauri.leukkunen@nokia.com
 * Licenced under GPL, see COPYING for details.
 */

#define _GNU_SOURCE

#include <stdio.h>
#include <libgen.h>
#include <unistd.h>
#include <string.h>
#include <stdlib.h>
#include <errno.h>

#define ALIEN_TOOL_DIR "/scratchbox/tools/alien_bin"
#define LIB_DIR        "/scratchbox/host_shared/lib/"
#define LD_PATH        LIB_DIR "ld.so"

int main(int argc, char **argv)
{
	char *tool_dir, *binaryname, *exe, **my_argv;
	int i = 0, j;

	tool_dir = getenv("SBOX_ALIEN_TOOL_DIR");
	if (!tool_dir)
		tool_dir = ALIEN_TOOL_DIR;

	binaryname = basename(strdup(argv[0]));

	exe = malloc(strlen(tool_dir) + strlen(binaryname) + 2);
	strcpy(exe, tool_dir);
	strcat(exe, "/");
	strcat(exe, binaryname);

	my_argv = calloc(4 + (argc - 1) + 1, sizeof (char **));
	my_argv[i++] = LD_PATH;
	my_argv[i++] = "--library-path";
	my_argv[i++] = LIB_DIR;
	my_argv[i++] = exe;

	for (j = 1; j < argc;  ++j)
		my_argv[i++] = argv[j];

	execv(my_argv[0], my_argv);

	fprintf(stderr, "sb_tool_wrapper (%s): %s\n", exe, strerror(errno));
	return 1;
}
